Linux运维工程师:30道面试题整理 | 张戈博客

  • 时间:
  • 浏览:6

11.Linux系统的开机启动顺序

加载BIOS–>读取MBR–>Boot Loader–>加载内核–>用户层init一句inittab文件来设定系统运行的等级(一般3不可能 5,3是多用户命令行,5是界面)–>inittcp连接执行rc.syninit–>启动内核模块–>执行不同级别运行的脚本tcp连接–>执行/etc/rc.d/rc.local(本地运行服务)–>执行/bin/login,就都才能 登录了。

12.符号链接与硬链接的区别

亲戚亲戚让让我们让让我们 都才能 把符号链接,也但是 我软连接 当做是 windows系统里的 快捷措施。

硬链接 就好像是 又复制了一份.

ln 3.txt 4.txt   这是硬链接,合适复制,不都才能 跨分区,但修改3,4会跟着变,若删除3,4不受任何影响。

ln -s 3.txt 4.txt  这是软连接,合适快捷措施。修改4,3也会跟着变,若删除3,4就坏掉了。不都才能 用了。

13.保存当前磁盘分区的分区表

dd 命令是以个强大的命令,在复制的同時 进行转换

dd if=/dev/sda of=./mbr.txt bs=1 count=512

14..都才能才能 14题,我此人 来个简单的,怎样才能在文本上方进行复制、粘贴,删除行,删除完正,按行查找和按字母查找。

以下操作完正在命令行情况操作,不用在编辑情况操作。

在文本里 移动到你要复制的行  按yy  想复制到哪就移动到哪,但是按P  就黏贴了

删除行  移动到改行 按dd

删除完正  dG  这里注意G一定要大写

按行查找  :90 原先但是 我找到第90行

按字母查找 /path  原先但是 我 找到path你是什么单词所在的位置,文本里不可能 所处多个,多次查找会显示在不同的位置。

15.手动安装grub

grub-install /dev/sda

16.修改内核参数

vi /etc/sysctl.conf  这里修改参数

sysctl -p  刷新后可用

17.在1-39内取随机数

expr $[$RANDOM%39] + 1

RANDOM 随机数

%39 取余数 范围 0-38

18.限制apache每秒新建连接数为1,峰值为3

每秒新建连接数 一般都有由防火墙来做,apache五种好像无法设置每秒新建连接数,都才能才能 设置最大连接:

iptables -A INPUT -d 172.16.80.1 -p tcp --dport 80 -m limit --limit 1/second  -j ACCEPT

硬件防火墙设置更简单,有界面化,都才能 直接填写数字。。。

最大连接 apache五种都才能 设置

MaxClients 3  ,修改apache最大连接 前提还是要修改系统默认tcp连接数。我博客里也说了,这就不说了。

19.FTP的主动模式和被动模式

FTP协议有五种工作措施:PORT措施和PASV措施,中文意思为主动式和被动式。

PORT(主动)措施的连接过程是:客户端向服务器的FTP端口(默认是21)发送连接请 求,服务器接受连接,建立一根绳子 命令链路。当都才能传送数据时,客户端在命令链路上用PORT 命令告诉服务器:“我打开了XX端口,你过来连接我”。于是服务器从20端口向客户端的 XX端口发送连接请求,建立一根绳子 数据链路来传送数据。

PASV(被动)措施的连接过程是:客户端向服务器的FTP端口(默认是21)发送连接请 求,服务器接受连接,建立一根绳子 命令链路。当都才能传送数据时,服务器在命令链路上用PASV 命令告诉客户端:“我打开了XX端口,你过来连接我”。于是客户端向服务器的XX端口 发送连接请求,建立一根绳子 数据链路来传送数据。

从上方都才能 看出,五种措施的命令链路连接措施是一样的,而数据链路的建立措施就完 全不同。

20.显示/etc/inittab中以#开头,且上方跟了几次多 不可能 多个空白字符,而后又跟了任意非空白字符的行

grep "^# \{1,\}[^ ]" /etc/inittab

21.显示/etc/inittab中涵盖了:几次多 数字:(即几次多 冒号上方几次多 数字)的行

grep "\:[0-9]\{1\}\:" /etc/inittab

22.为社 把脚本再加到系统服务里,即用service来调用

在脚本里加入

#!/bin/bash
# chkconfig: 345 85 15
# description: httpd

但是保存

chkconfig httpd –add  创建系统服务

现在就都才能 使用service 来 start or restart

23.写几次多 脚本,实现批量再加20个用户,用户名为user01-20,密码为user上方跟五个随机字符

#!/bin/bash
#description: useradd
for i in `seq -f"%02g" 1 20`;do
useradd user$i
echo "user$i:`echo $RANDOM|md5sum|cut -c 1-5`"|passwd –stdinuser$i >/dev/null 2>&1
done

24.写几次多 脚本,实现判断192.168.1.0/24网络里,当前在线的IP有哪几次,能ping通则认为在线

#!/bin/bash
for ip in `seq 1 255`
  do
    {
     ping -c 1 192.168.1.$ip > /dev/null 2>&1
     if [ $? -eq 0 ]; then
          echo 192.168.1.$ip UP
     else
          echo 192.168.1.$ip DOWN
     fi
   }&
done
wait

25.写几次多 脚本,判断几次多 指定的脚本有无语法错误;不可能 有错误,则提醒用户键入Q不可能 q无视错误并退出其它任何键都才能 通过vim打开你是什么指定的脚本

[[email protected]  tmp]# cat checksh.sh
 #!/bin/bash
 read -p "please input check script-> " file
 if [ -f $file ]; then
    sh -n $file > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        read -p "You input $file syntax error,[Type q to exit or Type vim to  edit]" answer
        case $answer in
        q | Q)
           exit 0
           ;;
        vim )
           vim $file
           ;;
        *)
         exit 0
         ;;
        esac
   fi
 else
    echo "$file not exist"
    exit 1
 fi

26、写几次多 脚本:(26包括五个小题)

1、创建几次多 函数,能接受几次多 参数:

1)第几次多 参数为URL,即可下载的文件;第五个参数为目录,即下载后保存的位置;

2)不可能 用户给的目录不所处,则提示用户有无创建;不可能 创建就继续执行,但是,函数返回几次多 51的错误值给调用脚本;

3)不可能 给的目录所处,则下载文件;下载命令执行刚结速后测试文件下载成功有无;不可能 成功,则返回0给调用脚本,但是,返回52给调用脚本;

[[email protected] tmp]# cat downfile.sh
#!/bin/bash
url=$1
dir=$2
download()
  {
    if [[ ! -d $dir ]];then
        read -p "$dir No such directory,create?(y/n)" answer
        if [[ "$answer" == "y" ]];then
            mkdir -p $dir
        else
            return "51"
        fi
    fi
    cd $dir && wget $url >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        return "52"
    fi
    return 0
}
download $url $dir
echo $?

27、写几次多 脚本:(27包括几次多 小题)

1、创建几次多 函数,都才能 接受几次多 磁盘设备路径(如/dev/sdb)作为参数;在真正刚结速上方步骤但是提醒用户有危险,并让用户确定有无继续;而后将此磁盘设备上的所有分区清空(提示,使用命令dd if=/dev/zero of=/dev/sdb bs=512 count=1实现,注意其中的设备路径不用写错了

不可能 此步骤失败,返回67给主tcp连接;

接着在此磁盘设备上创建几次多 主分区,几次多 大小为80M,几次多 大小为1G;不可能 此步骤失败,返回68给主tcp连接;

格式化此两分区,文件系统类型为ext3;不可能 此步骤失败,返回69给主tcp连接;

不可能 上述过程都正常,返回0给主tcp连接;

2、调用此函数;并通过接收函数执行的返回值来判断其执行情况,并将信息显示出来;

if [[ -n $1 && $1 =~ "/dev/sd[a-z]" ]];
then     
    local Darray=(`ls /dev/sd[a-z]`)
    for i in ${Darray};do
        [[ "$i" == "$1" ]] && Sd=$i && break
    done
else
    return 66
fi
#当匹配成功,进入确定,告诉用户,有无继续,输错得话进入无限循环,当用户确定Y,则清空目标分区,且出显while循环
while :;do
    read -p "Warning!!!This operation will clean $Sd data.Next=y,Quit=n [y|n]:" Choice
    case $Choice in
y)
   dd if=/dev/zero of=$Sd bs=512 count=1 &> /dev/null &&break || return 67 ;;
n)
   exit 88 ;;
*)
   echo "Invalid choice,please choice again." ;;
esac
done

#使用echo传递给fdisk进行分区,不可能 此命令失败,则跳转出去,错误值68,都才能注意的是,有但是你是什么返回值很诡异,笔者但是成功有无都有返回的1,但是重启但是,就好了,不可能 慎重得话,都才能 对创建的分区,进行判断,不过就都才能使用但是 工具截取相关字段了,虽但是 小麻烦,但无大碍

echo-e "n\np\n1\n\n+80M\nn\np\n2\n\n+1024M\nw\n"|fdisk /dev/sdb&> /dev/null || return 68

#格式化但是,让内核重新读取磁盘分区表,值得注意的是,有的系统版本,使用partprobe无效,譬如笔者的环境是rhel5.8,而rhel6.0但是,你是什么命令就很危险了,而使用partx -a /dev/sdb则效果更好…此项需慎重,不可能 格式化失败,则告知把失败的分区定义成变量,且出显函数,并带出错误值69

`partprobe`
Part=`fdisk -l /dev/$Sd|tail -2|cut -d” ” -f1`
for M in ${Part};do
   mke2fs -j $M &> /dev/null && ErrorPart=$M &&return 69
done
  return 0
}

#下面代码,调用函数,接收函数返回值,根据返回值进行判断哪里出错。

Disk_Mod $1
Res=$?
[ $Res-eq 0 ] && exit 0
[ $Res-eq 66 ] && echo "Error! Invalid input."
[ $Res-eq 67 ] && echo "Error! Command -> dd <- Faild."
[ $Res-eq 68 ] && echo "Error! Command -> fdisk <- Faild."
[ $Res-eq 69 ] && echo "Error! Command -> mke2fs <- Faild."